//-----------------------------------------------------------------------------
//                     A c t i v e   W o r l d s   A P I
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//                Copyright 1998-2010 Activeworlds Inc.
//      Licensed Material -- Program Property of Activeworlds Inc.
//                     Delphi translation by Vortex
//-----------------------------------------------------------------------------

unit aw;

interface

const
  AW_BUILD = 93;                        // AW 5.1

  // Limits
  AW_MAX_AVCHANGE_PER_SECOND = 10;
  AW_MAX_MESSAGES_PER_SECOND = 100;
  AW_MAX_WHISPERS_PER_SECOND = 100;
  AW_MAX_BOTGRAMS_PER_SECOND = 32;
  AW_CELL_MIN                = -32767;  // provided for old applications only
  AW_MAX_ATTRIBUTE_LENGTH    = 255;
  AW_MAX_USER_NAME_LENGTH    = 20;
  AW_MIN_USER_NAME_LENGTH    = 2;
  AW_MAX_PASSWORD_LENGTH     = 16;
  AW_MIN_PASSWORD_LENGTH     = 4;
  AW_MAX_EMAIL_LENGTH        = 64;
  AW_MAX_WORLD_NAME_LENGTH   = 16;
  AW_MAX_LONG_DATA           = 4094;

  AW_PERSONAL_AVATAR         = 65535;
  AW_CUSTOM_AVATAR           = 65534;
  AW_CUSTOM_WORLD_AVATAR     = 65533;

//-----------------------------------------------------------------------------
//                        o b j e c t  v e r s i o n s
//-----------------------------------------------------------------------------

  AW_OBJECT_VERSION_CAMERA     = 1;
  AW_OBJECT_VERSION_PARTICLES  = 1;
  AW_OBJECT_VERSION_ZONE       = 1;
  AW_OBJECT_VERSION_MOVER      = 1;
  AW_OBJECT_VERSION_CLOTH      = 1;

//-----------------------------------------------------------------------------
//                           a t t r i b u t e s
//-----------------------------------------------------------------------------

{$Z4}

type AW_ATTRIBUTE = (
  AW_LOGIN_NAME,
  AW_LOGIN_PASSWORD,
  AW_LOGIN_OWNER,
  AW_LOGIN_PRIVILEGE_PASSWORD,
  AW_LOGIN_PRIVILEGE_NUMBER,
  AW_LOGIN_PRIVILEGE_NAME,
  AW_LOGIN_APPLICATION,
  AW_LOGIN_EMAIL,
  AW_UNIVERSE_BROWSER_MINIMUM,
  AW_UNIVERSE_BROWSER_RELEASE,
  AW_UNIVERSE_BROWSER_BETA,
  AW_UNIVERSE_WORLD_MINIMUM,
  AW_UNIVERSE_WORLD_START,
  AW_UNIVERSE_REGISTRATION_REQUIRED,
  AW_UNIVERSE_BUILD_NUMBER,
  AW_UNIVERSE_MONTHLY_CHARGE,
  AW_UNIVERSE_ANNUAL_CHARGE,
  AW_UNIVERSE_REGISTER_METHOD,
  AW_UNIVERSE_TIME,
  AW_UNIVERSE_CITIZEN_CHANGES_ALLOWED,
  AW_UNIVERSE_BROWSER_RELEASE_22,
  AW_UNIVERSE_WELCOME_MESSAGE,
  AW_UNIVERSE_WORLD_RELEASE,
  AW_UNIVERSE_WORLD_BETA,
  AW_UNIVERSE_ALLOW_TOURISTS,
  AW_UNIVERSE_SEARCH_URL,
  AW_UNIVERSE_NOTEPAD_URL,
  AW_UNIVERSE_NAME,
  AW_UNIVERSE_USER_LIST_ENABLED,
  AW_CITIZEN_NUMBER,
  AW_CITIZEN_NAME,
  AW_CITIZEN_PASSWORD,
  AW_CITIZEN_EMAIL,
  AW_CITIZEN_TIME_LEFT,
  AW_CITIZEN_PRIVILEGE_PASSWORD,
  AW_CITIZEN_IMMIGRATION_TIME,
  AW_CITIZEN_EXPIRATION_TIME,
  AW_CITIZEN_BETA,
  AW_CITIZEN_LAST_LOGIN,
  AW_CITIZEN_BOT_LIMIT,
  AW_CITIZEN_TOTAL_TIME,
  AW_CITIZEN_ENABLED,
  AW_CITIZEN_COMMENT,
  AW_CITIZEN_URL,
  AW_WORLD_NAME,
  AW_WORLD_TITLE,
  AW_WORLD_BACKDROP,
  AW_WORLD_GROUND,
  AW_WORLD_OBJECT_PATH,
  AW_WORLD_OBJECT_REFRESH,
  AW_WORLD_BUILD_RIGHT,
  AW_WORLD_EMINENT_DOMAIN_RIGHT,
  AW_WORLD_ENTER_RIGHT,
  AW_WORLD_SPECIAL_OBJECTS_RIGHT,
  AW_WORLD_FOG_RED,
  AW_WORLD_FOG_GREEN,
  AW_WORLD_FOG_BLUE,
  AW_WORLD_CARETAKER_CAPABILITY,
  AW_WORLD_RESTRICTED_RADIUS,
  AW_WORLD_PUBLIC_SPEAKER_CAPABILITY,
  AW_WORLD_PUBLIC_SPEAKER_RIGHT,
  AW_WORLD_CREATION_TIMESTAMP,
  AW_WORLD_HOME_PAGE,
  AW_WORLD_BUILD_NUMBER,
  AW_WORLD_OBJECT_PASSWORD,
  AW_WORLD_DISABLE_CREATE_URL,
  AW_WORLD_RATING,
  AW_WORLD_WELCOME_MESSAGE,
  AW_WORLD_EJECT_RIGHT,
  AW_WORLD_EJECT_CAPABILITY,
  AW_WORLD_CELL_LIMIT,
  AW_WORLD_BUILD_CAPABILITY,
  AW_WORLD_ALLOW_PASSTHRU,
  AW_WORLD_ALLOW_FLYING,
  AW_WORLD_ALLOW_TELEPORT,
  AW_WORLD_ALLOW_OBJECT_SELECT,
  AW_WORLD_BOTS_RIGHT,
  AW_WORLD_SPEAK_CAPABILITY,
  AW_WORLD_SPEAK_RIGHT,
  AW_WORLD_ALLOW_TOURIST_WHISPER,
  AW_WORLD_LIGHT_X,
  AW_WORLD_LIGHT_Y,
  AW_WORLD_LIGHT_Z,
  AW_WORLD_LIGHT_RED,
  AW_WORLD_LIGHT_GREEN,
  AW_WORLD_LIGHT_BLUE,
  AW_WORLD_AMBIENT_LIGHT_RED,
  AW_WORLD_AMBIENT_LIGHT_GREEN,
  AW_WORLD_AMBIENT_LIGHT_BLUE,
  AW_WORLD_ALLOW_AVATAR_COLLISION,
  AW_WORLD_FOG_ENABLE,
  AW_WORLD_FOG_MINIMUM,
  AW_WORLD_FOG_MAXIMUM,
  AW_WORLD_FOG_TINTED,
  AW_WORLD_MAX_USERS,
  AW_WORLD_SIZE,
  AW_WORLD_OBJECT_COUNT,
  AW_WORLD_EXPIRATION,
  AW_WORLD_SPECIAL_COMMANDS_RIGHT,
  AW_WORLD_MAX_LIGHT_RADIUS,
  AW_WORLD_SKYBOX,
  AW_WORLD_MINIMUM_VISIBILITY,
  AW_WORLD_REPEATING_GROUND,
  AW_WORLD_KEYWORDS,
  AW_WORLD_ENABLE_TERRAIN,
  AW_WORLD_ALLOW_3_AXIS_ROTATION,
  AW_WORLD_TERRAIN_TIMESTAMP,
  AW_WORLD_ENTRY_POINT,
  AW_WORLD_SKY_NORTH_RED,
  AW_WORLD_SKY_NORTH_GREEN,
  AW_WORLD_SKY_NORTH_BLUE,
  AW_WORLD_SKY_SOUTH_RED,
  AW_WORLD_SKY_SOUTH_GREEN,
  AW_WORLD_SKY_SOUTH_BLUE,
  AW_WORLD_SKY_EAST_RED,
  AW_WORLD_SKY_EAST_GREEN,
  AW_WORLD_SKY_EAST_BLUE,
  AW_WORLD_SKY_WEST_RED,
  AW_WORLD_SKY_WEST_GREEN,
  AW_WORLD_SKY_WEST_BLUE,
  AW_WORLD_SKY_TOP_RED,
  AW_WORLD_SKY_TOP_GREEN,
  AW_WORLD_SKY_TOP_BLUE,
  AW_WORLD_SKY_BOTTOM_RED,
  AW_WORLD_SKY_BOTTOM_GREEN,
  AW_WORLD_SKY_BOTTOM_BLUE,
  AW_WORLD_CLOUDS_LAYER1_TEXTURE,
  AW_WORLD_CLOUDS_LAYER1_MASK,
  AW_WORLD_CLOUDS_LAYER1_TILE,
  AW_WORLD_CLOUDS_LAYER1_SPEED_X,
  AW_WORLD_CLOUDS_LAYER1_SPEED_Z,
  AW_WORLD_CLOUDS_LAYER1_OPACITY,
  AW_WORLD_CLOUDS_LAYER2_TEXTURE,
  AW_WORLD_CLOUDS_LAYER2_MASK,
  AW_WORLD_CLOUDS_LAYER2_TILE,
  AW_WORLD_CLOUDS_LAYER2_SPEED_X,
  AW_WORLD_CLOUDS_LAYER2_SPEED_Z,
  AW_WORLD_CLOUDS_LAYER2_OPACITY,
  AW_WORLD_CLOUDS_LAYER3_TEXTURE,
  AW_WORLD_CLOUDS_LAYER3_MASK,
  AW_WORLD_CLOUDS_LAYER3_TILE,
  AW_WORLD_CLOUDS_LAYER3_SPEED_X,
  AW_WORLD_CLOUDS_LAYER3_SPEED_Z,
  AW_WORLD_CLOUDS_LAYER3_OPACITY,
  AW_WORLD_DISABLE_CHAT,
  AW_WORLD_ALLOW_CITIZEN_WHISPER,
  AW_WORLD_ALWAYS_SHOW_NAMES,
  AW_WORLD_DISABLE_AVATAR_LIST,
  AW_WORLD_AVATAR_REFRESH_RATE,
  AW_WORLD_WATER_TEXTURE,
  AW_WORLD_WATER_MASK,
  AW_WORLD_WATER_BOTTOM_TEXTURE,
  AW_WORLD_WATER_BOTTOM_MASK,
  AW_WORLD_WATER_OPACITY,
  AW_WORLD_WATER_RED,
  AW_WORLD_WATER_GREEN,
  AW_WORLD_WATER_BLUE,
  AW_WORLD_WATER_LEVEL,
  AW_WORLD_WATER_SURFACE_MOVE,
  AW_WORLD_WATER_WAVE_MOVE,
  AW_WORLD_WATER_SPEED,
  AW_WORLD_WATER_ENABLED,
  AW_WORLD_EMINENT_DOMAIN_CAPABILITY,
  AW_WORLD_LIGHT_TEXTURE,
  AW_WORLD_LIGHT_MASK,
  AW_WORLD_LIGHT_DRAW_SIZE,
  AW_WORLD_LIGHT_DRAW_FRONT,
  AW_WORLD_LIGHT_DRAW_BRIGHT,
  AW_WORLD_LIGHT_SOURCE_USE_COLOR,
  AW_WORLD_LIGHT_SOURCE_COLOR,
  AW_WORLD_TERRAIN_AMBIENT,
  AW_WORLD_TERRAIN_DIFFUSE,
  AW_WORLD_WATER_VISIBILITY,
  AW_WORLD_SOUND_FOOTSTEP,
  AW_WORLD_SOUND_WATER_ENTER,
  AW_WORLD_SOUND_WATER_EXIT,
  AW_WORLD_SOUND_AMBIENT,
  AW_WORLD_GRAVITY,
  AW_WORLD_BUOYANCY,
  AW_WORLD_FRICTION,
  AW_WORLD_WATER_FRICTION,
  AW_WORLD_SLOPESLIDE_ENABLED,
  AW_WORLD_SLOPESLIDE_MIN_ANGLE,
  AW_WORLD_SLOPESLIDE_MAX_ANGLE,
  AW_WORLD_ALLOW_TOURIST_BUILD,
  AW_WORLD_ENABLE_REFERER,
  AW_WORLD_WATER_UNDER_TERRAIN,
  AW_WORLD_TERRAIN_OFFSET,
  AW_WORLD_VOIP_RIGHT,
  AW_WORLD_DISABLE_MULTIPLE_MEDIA,
  AW_WORLD_BOTMENU_URL,
  AW_WORLD_ENABLE_BUMP_EVENT,
  AW_WORLD_ENABLE_SYNC_EVENTS,
  AW_WORLD_ENABLE_CAV,
  AW_WORLD_ENABLE_PAV,
  AW_WORLD_CHAT_DISABLE_URL_CLICKS,
  AW_WORLD_MOVER_EMPTY_RESET_TIMEOUT,
  AW_WORLD_MOVER_USED_RESET_TIMEOUT,
  AW_MY_X,
  AW_MY_Y,
  AW_MY_Z,
  AW_MY_YAW,
  AW_MY_PITCH,
  AW_MY_TYPE,
  AW_MY_GESTURE,
  AW_MY_STATE,
  AW_AVATAR_SESSION,
  AW_AVATAR_NAME,
  AW_AVATAR_X,
  AW_AVATAR_Y,
  AW_AVATAR_Z,
  AW_AVATAR_YAW,
  AW_AVATAR_PITCH,
  AW_AVATAR_TYPE,
  AW_AVATAR_GESTURE,
  AW_AVATAR_STATE,
  AW_AVATAR_ADDRESS,
  AW_AVATAR_VERSION,
  AW_AVATAR_CITIZEN,
  AW_AVATAR_PRIVILEGE,
  AW_AVATAR_LOCK,
  AW_AVATAR_FLAGS,
  AW_CHAT_SESSION,
  AW_CHAT_MESSAGE,
  AW_CELL_X,
  AW_CELL_Z,
  AW_CELL_SEQUENCE,
  AW_CELL_SIZE,
  AW_CELL_ITERATOR,
  AW_CELL_COMBINE,
  AW_OBJECT_ID,
  AW_OBJECT_NUMBER,
  AW_OBJECT_X,
  AW_OBJECT_Y,
  AW_OBJECT_Z,
  AW_OBJECT_YAW,
  AW_OBJECT_TILT,
  AW_OBJECT_ROLL,
  AW_OBJECT_MODEL,
  AW_OBJECT_DESCRIPTION,
  AW_OBJECT_ACTION,
  AW_OBJECT_OLD_NUMBER,
  AW_OBJECT_OLD_X,
  AW_OBJECT_OLD_Z,
  AW_OBJECT_OWNER,
  AW_OBJECT_SESSION,
  AW_OBJECT_BUILD_TIMESTAMP,
  AW_OBJECT_SYNC,
  AW_OBJECT_TYPE,
  AW_OBJECT_DATA,
  AW_QUERY_COMPLETE,
  AW_CHAT_TYPE,
  AW_LICENSE_NAME,
  AW_LICENSE_PASSWORD,
  AW_LICENSE_USERS,
  AW_LICENSE_RANGE,
  AW_LICENSE_EMAIL,
  AW_LICENSE_COMMENT,
  AW_LICENSE_CREATION_TIME,
  AW_LICENSE_EXPIRATION_TIME,
  AW_LICENSE_LAST_START,
  AW_LICENSE_LAST_ADDRESS,
  AW_LICENSE_HIDDEN,
  AW_LICENSE_ALLOW_TOURISTS,
  AW_LICENSE_VOIP,
  AW_LICENSE_PLUGINS,
  AW_WORLDLIST_NAME,
  AW_WORLDLIST_STATUS,
  AW_WORLDLIST_USERS,
  AW_WORLDLIST_RATING,
  AW_WORLDLIST_MORE,
  AW_EJECT_SESSION,
  AW_EJECT_DURATION,
  AW_EJECTION_TYPE,
  AW_EJECTION_ADDRESS,
  AW_EJECTION_EXPIRATION_TIME,
  AW_EJECTION_CREATION_TIME,
  AW_EJECTION_COMMENT,
  AW_DISCONNECT_REASON,
  AW_FILE_RECIPIENT,
  AW_FILE_SENDER,
  AW_FILE_SENDER_NAME,
  AW_FILE_SESSION,
  AW_FILE_ADDRESS,
  AW_FILE_PORT,
  AW_CLICKED_SESSION,
  AW_CLICKED_NAME,
  AW_URL_NAME,
  AW_URL_POST,
  AW_URL_TARGET,
  AW_URL_TARGET_3D,
  AW_TELEPORT_WORLD,
  AW_TELEPORT_X,
  AW_TELEPORT_Y,
  AW_TELEPORT_Z,
  AW_TELEPORT_YAW,
  AW_TELEPORT_WARP,
  AW_SERVER_BUILD,
  AW_SERVER_NAME,
  AW_SERVER_PASSWORD,
  AW_SERVER_REGISTRY,
  AW_SERVER_CARETAKERS,
  AW_SERVER_ID,
  AW_SERVER_INSTANCE,
  AW_SERVER_ENABLED,
  AW_SERVER_STATE,
  AW_SERVER_USERS,
  AW_SERVER_MAX_USERS,
  AW_SERVER_OBJECTS,
  AW_SERVER_SIZE,
  AW_SERVER_EXPIRATION,
  AW_SERVER_START_RC,
  AW_SERVER_MORE,
  AW_SERVER_TERRAIN_NODES,
  AW_TERRAIN_X,
  AW_TERRAIN_Z,
  AW_TERRAIN_PAGE_X,
  AW_TERRAIN_PAGE_Z,
  AW_TERRAIN_NODE_X,
  AW_TERRAIN_NODE_Z,
  AW_TERRAIN_NODE_SIZE,
  AW_TERRAIN_NODE_TEXTURE_COUNT,
  AW_TERRAIN_NODE_HEIGHT_COUNT,
  AW_TERRAIN_NODE_TEXTURES,
  AW_TERRAIN_NODE_HEIGHTS,
  AW_TERRAIN_SEQUENCE,
  AW_TERRAIN_COMPLETE,
  AW_TERRAIN_VERSION_NEEDED,
  AW_ENTER_GLOBAL,
  AW_CONSOLE_RED,
  AW_CONSOLE_GREEN,
  AW_CONSOLE_BLUE,
  AW_CONSOLE_BOLD,
  AW_CONSOLE_ITALICS,
  AW_CONSOLE_MSG,
  AW_BOTGRAM_TO,
  AW_BOTGRAM_FROM,
  AW_BOTGRAM_FROM_NAME,
  AW_BOTGRAM_TYPE,
  AW_BOTGRAM_TEXT,
  AW_TOOLBAR_ID,
  AW_TOOLBAR_SESSION,
  AW_USERLIST_MORE,
  AW_USERLIST_NAME,
  AW_USERLIST_WORLD,
  AW_USERLIST_EMAIL,
  AW_USERLIST_CITIZEN,
  AW_USERLIST_PRIVILEGE,
  AW_USERLIST_STATE,
  AW_USERLIST_ADDRESS,
  AW_USERLIST_ID,
  AW_SOUND_NAME,
  AW_CAMERA_LOCATION_TYPE,
  AW_CAMERA_LOCATION_OBJECT,
  AW_CAMERA_LOCATION_SESSION,
  AW_CAMERA_TARGET_TYPE,
  AW_CAMERA_TARGET_OBJECT,
  AW_CAMERA_TARGET_SESSION,
  AW_PLUGIN_STRING,
  AW_BOTMENU_TO_SESSION,
  AW_BOTMENU_FROM_NAME,
  AW_BOTMENU_FROM_SESSION,
  AW_BOTMENU_QUESTION,
  AW_BOTMENU_ANSWER,

  // attributes below are not used by the SDK

  AW_CONTACT_NUMBER,
  AW_CONTACT_STATUS,
  AW_CONTACT_NAME,
  AW_CONTACT_WORLD,
  AW_CONTACT_MORE,
  AW_CONTACT_OPTIONS,
  AW_TELEGRAM_TO,
  AW_TELEGRAM_FROM,
  AW_TELEGRAM_TEXT,
  AW_TELEGRAM_SENT,
  AW_TELEGRAM_MORE,
  AW_JOIN_NAME,
  AW_JOIN_CITIZEN,
  AW_JOIN_WORLD,
  AW_JOIN_X,
  AW_JOIN_Y,
  AW_JOIN_Z,
  AW_JOIN_YAW,
  AW_REGISTER_CC_NAME,
  AW_REGISTER_CC_NUMBER,
  AW_REGISTER_CC_MONTH,
  AW_REGISTER_CC_YEAR,
  AW_REGISTER_ADDRESS,
  AW_REGISTER_CITY,
  AW_REGISTER_STATE,
  AW_REGISTER_ZIP,
  AW_REGISTER_PHONE_NUMBER,
  AW_REGISTER_BUSINESS_NAME,
  AW_REGISTER_VENDOR,
  AW_REGISTER_RESULT,
  AW_REGISTER_METHOD,
  AW_VOIP_DATA,

  // attributes below are used by the SDK
  AW_UNIVERSE_CAV_PATH,
  AW_CITIZEN_PAV_ENABLED,
  AW_CAV_CITIZEN,
  AW_CAV_DEFINITION,
  AW_ENTITY_TYPE,
  AW_ENTITY_ID,
  AW_ENTITY_STATE,
  AW_ENTITY_FLAGS,
  AW_ENTITY_X,
  AW_ENTITY_Y,
  AW_ENTITY_Z,
  AW_ENTITY_YAW,
  AW_ENTITY_PITCH,
  AW_ENTITY_ROLL,
  AW_ENTITY_OWNER_SESSION,
  AW_ENTITY_OWNER_CITIZEN,
  AW_AVATAR_DISTANCE,
  AW_AVATAR_ANGLE,
  AW_AVATAR_Y_DELTA,
  AW_AVATAR_YAW_DELTA,
  AW_AVATAR_PITCH_DELTA,
  AW_AVATAR_WORLD_INSTANCE,
  AW_ATTRIB_SENDER_SESSION,
  AW_ENTITY_MODEL_NUM,
  AW_WORLD_V4_OBJECTS_RIGHT,
  AW_CITIZEN_LAST_ADDRESS,
  AW_HUD_ELEMENT_TYPE,
  AW_HUD_ELEMENT_ID,
  AW_HUD_ELEMENT_SESSION,
  AW_HUD_ELEMENT_ORIGIN,
  AW_HUD_ELEMENT_X,
  AW_HUD_ELEMENT_Y,
  AW_HUD_ELEMENT_Z,
  AW_HUD_ELEMENT_FLAGS,
  AW_HUD_ELEMENT_TEXT,
  AW_HUD_ELEMENT_COLOR,
  AW_HUD_ELEMENT_OPACITY,
  AW_HUD_ELEMENT_SIZE_X,
  AW_HUD_ELEMENT_SIZE_Y,
  AW_HUD_ELEMENT_SIZE_Z,
  AW_HUD_ELEMENT_CLICK_X,
  AW_HUD_ELEMENT_CLICK_Y,
  AW_HUD_ELEMENT_CLICK_Z,
  AW_HUD_ELEMENT_TEXTURE_OFFSET_X,
  AW_HUD_ELEMENT_TEXTURE_OFFSET_Y,
  AW_CITIZEN_PRIVACY,
  AW_CITIZEN_TRIAL,
  AW_UNIVERSE_CAV_PATH2,
  AW_WORLD_DISABLE_SHADOWS,
  AW_WORLD_ENABLE_CAMERA_COLLISION,
  AW_WORLD_SPECIAL_COMMANDS,
  AW_UNIVERSE_OBJECT_REFRESH,
  AW_UNIVERSE_OBJECT_PASSWORD,
  AW_CAV_SESSION,
  AW_CITIZEN_CAV_ENABLED,
  AW_WORLD_CAV_OBJECT_PATH,
  AW_WORLD_CAV_OBJECT_PASSWORD,
  AW_WORLD_CAV_OBJECT_REFRESH,
  AW_OBJECT_CALLBACK_REFERENCE,
  AW_WORLD_TERRAIN_RIGHT,
  AW_UNIVERSE_ALLOW_TOURISTS_CAV,
  AW_UNIVERSE_ALLOW_BOTS_CAV,
  AW_WORLD_VOIP_CONFERENCE_GLOBAL,
  AW_WORLD_VOIP_MODERATE_GLOBAL,
  AW_OBJECT_SESSION_TO,
  AW_WORLD_CAMERA_ZOOM,
  AW_WORLD_WAIT_LIMIT,

  AW_XFER_DISCONNECT_REASON,
  AW_XFER_TYPE,
  AW_XFER_FROM_SESSION,
  AW_XFER_FROM_NAME,
  AW_XFER_TO_SESSION,
  AW_XFER_TO_NAME,
  AW_XFER_TO_WORLD_NAME,
  AW_XFER_TO_ZONE_NAME,
  AW_XFER_TO_TAG_NAME,
  AW_XFER_DATA_ID,
  AW_XFER_DATA_FILE_NAME,
  AW_XFER_DATA_LEN_TOTAL,
  AW_XFER_DATA_LEN_OFFSET,
  AW_XFER_DATA,
  AW_XFER_DATA2,
  AW_XFER_DATA3,
  AW_XFER_DATA_MORE,
  AW_XFER_RC,
  AW_XFER_SHOW_NAME,
  AW_XFER_OPTIONS,
  AW_XFER_EXPIRATION,
  AW_LICENSE_XFER_SHOW_RIGHTS,
  AW_XFER_SHOW_CAPABILITY,
  AW_XFER_SHOW_SEQUENCE,

  AW_LASER_BEAM_SOURCE_TYPE,
  AW_LASER_BEAM_SOURCE_ID,
  AW_LASER_BEAM_SOURCE_X,
  AW_LASER_BEAM_SOURCE_Y,
  AW_LASER_BEAM_SOURCE_Z,
  AW_LASER_BEAM_TARGET_TYPE,
  AW_LASER_BEAM_TARGET_ID,
  AW_LASER_BEAM_TARGET_X,
  AW_LASER_BEAM_TARGET_Y,
  AW_LASER_BEAM_TARGET_Z,
  AW_LASER_BEAM_STYLE,
  AW_LASER_BEAM_COLOR,
  AW_LASER_BEAM_DEFINITION,

  AW_WORLD_VOIPCAST_HOST,
  AW_WORLD_VOIPCAST_PORT,

  AW_MY_ZONE,
  AW_AVATAR_ZONE,

  AW_UNIVERSE_PER_CITIZEN_CAV,

  AW_XFER_OWNER,

  AW_WORLD_ENABLE_WIREFRAME,

  AW_MAX_ATTRIBUTE
);

type AW_EVENT_ATTRIBUTE = (
  AW_EVENT_AVATAR_ADD,
  AW_EVENT_AVATAR_CHANGE,
  AW_EVENT_AVATAR_DELETE,
  AW_EVENT_CELL_BEGIN,
  AW_EVENT_CELL_OBJECT,
  AW_EVENT_CELL_END,
  AW_EVENT_CHAT,
  AW_EVENT_OBJECT_ADD,
  AW_EVENT_OBJECT_DELETE,
  AW_EVENT_UNIVERSE_ATTRIBUTES,
  AW_EVENT_UNIVERSE_DISCONNECT,
  AW_EVENT_WORLD_ATTRIBUTES,
  AW_EVENT_WORLD_INFO,
  AW_EVENT_WORLD_DISCONNECT,
  AW_EVENT_SEND_FILE,
  AW_EVENT_CONTACT_STATE,
  AW_EVENT_TELEGRAM,
  AW_EVENT_JOIN,
  AW_EVENT_OBJECT_CLICK,
  AW_EVENT_OBJECT_SELECT,
  AW_EVENT_AVATAR_CLICK,
  AW_EVENT_URL,
  AW_EVENT_URL_CLICK,
  AW_EVENT_TELEPORT,
  AW_EVENT_ADMIN_WORLD_INFO,
  AW_EVENT_ADMIN_WORLD_DELETE,
  AW_EVENT_TERRAIN_BEGIN,
  AW_EVENT_TERRAIN_DATA,
  AW_EVENT_TERRAIN_END,
  AW_EVENT_CONSOLE_MESSAGE,
  AW_EVENT_TERRAIN_CHANGED,
  AW_EVENT_BOTGRAM,
  AW_EVENT_TOOLBAR_CLICK,
  AW_EVENT_USER_INFO,
  AW_EVENT_VOIP_DATA,
  AW_EVENT_NOISE,
  AW_EVENT_CAMERA,
  AW_EVENT_BOTMENU,
  AW_EVENT_OBJECT_BUMP,
  AW_EVENT_ENTITY_ADD,
  AW_EVENT_ENTITY_CHANGE,
  AW_EVENT_ENTITY_DELETE,
  AW_EVENT_ENTITY_RIDER_ADD,
  AW_EVENT_ENTITY_RIDER_DELETE,
  AW_EVENT_ENTITY_RIDER_CHANGE,
  AW_EVENT_AVATAR_RELOAD,
  AW_EVENT_ENTITY_LINKS,
  AW_EVENT_HUD_CLICK,
  AW_EVENT_HUD_CREATE,
  AW_EVENT_HUD_DESTROY,
  AW_EVENT_HUD_CLEAR,
  AW_EVENT_CAV_DEFINITION_CHANGE,
  AW_EVENT_WORLD_CAV_DEFINITION_CHANGE,

  AW_EVENT_XFER_DISCONNECT,
  AW_EVENT_XFER_OFFER,
  AW_EVENT_XFER_REPLY,
  AW_EVENT_XFER_SEND,
  AW_EVENT_XFER_REQUEST,
  AW_EVENT_XFER_CANCEL,

  AW_EVENT_LASER_BEAM,
  AW_EVENT_XFER_QUERY,

  AW_MAX_EVENT
);

type AW_CALLBACK_ATTRIBUTE = (
  AW_CALLBACK_CREATE,
  AW_CALLBACK_LOGIN,
  AW_CALLBACK_ENTER,
  AW_CALLBACK_OBJECT_RESULT,
  AW_CALLBACK_LICENSE_ATTRIBUTES,
  AW_CALLBACK_LICENSE_RESULT,
  AW_CALLBACK_CITIZEN_ATTRIBUTES,
  AW_CALLBACK_CITIZEN_RESULT,
  AW_CALLBACK_QUERY,
  AW_CALLBACK_WORLD_LIST,
  AW_CALLBACK_SEND_FILE,
  AW_CALLBACK_JOIN,
  AW_CALLBACK_PASSWORD_SEND,
  AW_CALLBACK_IMMIGRATE,
  AW_CALLBACK_REGISTER,
  AW_CALLBACK_UNIVERSE_EJECTION,
  AW_CALLBACK_UNIVERSE_EJECTION_RESULT,
  AW_CALLBACK_ADDRESS,
  AW_CALLBACK_WORLD_EJECTION,
  AW_CALLBACK_WORLD_EJECTION_RESULT,
  AW_CALLBACK_ADMIN_WORLD_LIST,
  AW_CALLBACK_ADMIN_WORLD_RESULT,
  AW_CALLBACK_DELETE_ALL_OBJECTS_RESULT,
  AW_CALLBACK_CELL_RESULT,
  AW_CALLBACK_RELOAD_REGISTRY,
  AW_CALLBACK_ATTRIBUTES_RESET_RESULT,
  AW_CALLBACK_ADMIN,
  AW_CALLBACK_CONTACT_ADD,
  AW_CALLBACK_TELEGRAM_RESULT,
  AW_CALLBACK_TERRAIN_SET_RESULT,
  AW_CALLBACK_TERRAIN_NEXT_RESULT,
  AW_CALLBACK_TERRAIN_DELETE_ALL_RESULT,
  AW_CALLBACK_TERRAIN_LOAD_NODE_RESULT,
  AW_CALLBACK_BOTGRAM_RESULT,
  AW_CALLBACK_USER_LIST,
  AW_CALLBACK_BOTMENU_RESULT,
  AW_CALLBACK_CAV,
  AW_CALLBACK_CAV_RESULT,
  AW_CALLBACK_WORLD_INSTANCE,
  AW_CALLBACK_HUD_RESULT,
  AW_CALLBACK_AVATAR_LOCATION,
  AW_CALLBACK_OBJECT_QUERY,
  AW_CALLBACK_WORLD_CAV_RESULT,
  AW_CALLBACK_WORLD_CAV,
  AW_CALLBACK_XFER_LOGIN,
  AW_CALLBACK_XFER_REQUEST_SHOW_REPLY,
  AW_MAX_CALLBACK
);

type AW_CHAT_TYPES = (
  AW_CHAT_SAID,
  AW_CHAT_BROADCAST,
  AW_CHAT_WHISPER
);

type AW_CONTACT_STATES = (
  AW_CONTACT_OFFLINE,
  AW_CONTACT_ONLINE,
  AW_CONTACT_NOT_A_CITIZEN,
  AW_CONTACT_AFK,
  AW_CONTACT_UNKNOWN,
  AW_CONTACT_DELETE
);

type AW_WORLD_STATES = (
  AW_WORLDSTATUS_UNKNOWN,
  AW_WORLDSTATUS_PUBLIC,
  AW_WORLDSTATUS_PRIVATE,
  AW_WORLDSTATUS_STOPPED
);

type AW_SERVER_STATES = (
  AW_SERVER_STOPPED,
  AW_SERVER_STARTING,
  AW_SERVER_START_WAIT,
  AW_SERVER_RUNNING
);

type AW_CONNECTION_TYPES = (
  AW_CONNECTION_DIRECT,
  AW_CONNECTION_FIREWALL_NO_PROXY,
  AW_CONNECTION_PROXY_AUTO,
  AW_CONNECTION_PROXY_NO_AUTH,
  AW_CONNECTION_PROXY_BASIC,
  AW_CONNECTION_PROXY_AUTH_NTLM,
  AW_CONNECTION_MAX
);

type AW_CONNECTION_STATES = (
  AW_CONNECTION_STATE_NOT_CONNECTED,
  AW_CONNECTION_STATE_CONNECTING_TO_PROXY,
  AW_CONNECTION_STATE_NEGOTIATING_WITH_PROXY,
  AW_CONNECTION_STATE_CONNECTING_TO_TUNNEL,
  AW_CONNECTION_STATE_CONNECTING_TO_UNIVERSE,
  AW_CONNECTION_STATE_CONNECTED,
  AW_CONNECTION_STATE_PASSWORD_REQUIRED
);

type AW_EJECTION_TYPES = (
  AW_EJECT_BY_ADDRESS,
  AW_EJECT_BY_COMPUTER,
  AW_EJECT_BY_CITIZEN
);

type AW_AVATAR_STATES = (
  AW_AVATAR_STATE_WALKING,
  AW_AVATAR_STATE_RUNNING,
  AW_AVATAR_STATE_FLYING,
  AW_AVATAR_STATE_SWIMMING,
  AW_AVATAR_STATE_FALLING,
  AW_AVATAR_STATE_JUMPING,
  AW_AVATAR_STATE_WARPING,
  AW_AVATAR_STATE_RIDING,
  AW_AVATAR_STATE_SLIDING1,
  AW_AVATAR_STATE_SLIDING2,
  AW_AVATAR_STATE_SLIDING3,
  AW_AVATAR_STATE_CLIMBING
);

type AW_ZONE_TYPES = (
  AW_ZONE_TYPE_CUBE,
  AW_ZONE_TYPE_CYLINDER,
  AW_ZONE_TYPE_SPHERE
);

type AW_PARTICLE_TYPES = (
  AW_PARTICLE_TYPE_SPRITE,
  AW_PARTICLE_TYPE_FACER,
  AW_PARTICLE_TYPE_FLAT,
  AW_PARTICLE_TYPE_OBJECT
);

type AW_PARTICLE_DRAW_STYLES = (
  AW_PARTICLE_DRAW_NORMAL,
  AW_PARTICLE_DRAW_BRIGHT,
  AW_PARTICLE_DRAW_GLOW
);

type AW_CAMERA_TYPES = (
  AW_CAMERA_TRACK_DEFAULT,
  AW_CAMERA_TRACK_AVATAR,
  AW_CAMERA_TRACK_OBJECT,
  AW_CAMERA_TRACK_AHEAD,
  AW_CAMERA_TRACK_SELF_FIRST_PERSON,
  AW_CAMERA_TRACK_SELF_LOCKED,
  AW_CAMERA_TRACK_SELF_CHASE,
  AW_CAMERA_TRACK_SELF_FRONT
);

type AW_REGISTER_METHODS = (
  AW_REGISTER_MONTHLY,
  AW_REGISTER_ANNUAL,
  AW_REGISTER_USER
);

type AW_AVATAR_SET_FLAGS = (
  AW_AVATAR_SET_NONE      = $00,
  AW_AVATAR_SET_POSITION  = $01,
  AW_AVATAR_SET_TYPE      = $02,
  AW_AVATAR_SET_GESTURE   = $04,
  AW_AVATAR_SET_STATE     = $08
);

type AW_ENTITY_TYPES = (
  AW_ENTITY_AVATAR, // not used as such
  AW_ENTITY_MOVER
);

type AW_MOVER_STATE_TYPES = (
  AW_MOVER_STATE_IDLE,    // never set by SDK
  AW_MOVER_STATE_START,
  AW_MOVER_STATE_MOVE,    // never set by SDK
  AW_MOVER_STATE_PAUSE,
  AW_MOVER_STATE_CONTINUE,
  AW_MOVER_STATE_STOP,
  AW_MOVER_STATE_RESET
);

type AW_MOVER_FLAGS = (
  AW_MOVER_FLAG_LOOP                  = $00000001,
  AW_MOVER_FLAG_USE_OBJTAG            = $00000002,
  AW_MOVER_FLAG_BUMP_ADD              = $00000004,
  AW_MOVER_FLAG_CLICK_START           = $00000008,
  AW_MOVER_FLAG_CLICK_PAUSE           = $00000010,
  AW_MOVER_FLAG_LOCK_POSITION         = $00000020,
  AW_MOVER_FLAG_LOCK_YAW              = $00000040,
  AW_MOVER_FLAG_LOCK_PITCH            = $00000080,
  AW_MOVER_FLAG_SINGLE_RIDER          = $00000100,
  AW_MOVER_FLAG_NO_AUTO_YAW           = $00000200,
  AW_MOVER_FLAG_EMPTY_RESET           = $00000400,
  AW_MOVER_FLAG_DISABLE_FLYING        = $00000800,
  AW_MOVER_FLAG_KEEP_ON_WATER         = $00001000,
  AW_MOVER_FLAG_DISABLE_UPWARDS       = $00002000,
  AW_MOVER_FLAG_INVISIBLE_AV          = $00004000,
  AW_MOVER_FLAG_EXIT_EJECT_UP         = $00008000,
  AW_MOVER_FLAG_EXIT_NON_SOLID        = $00010000,
  AW_MOVER_FLAG_AV_APPLY_TILT_X       = $00020000,
  AW_MOVER_FLAG_AV_APPLY_TILT_Z       = $00040000,
  AW_MOVER_FLAG_OBJECT_LINK           = $00080000,
  AW_MOVER_FLAG_DISABLE_MOVE          = $00100000,
  AW_MOVER_FLAG_TILT_BY_TERRAIN       = $00200000,
  AW_MOVER_FLAG_DISABLE_EXPL_SEQS     = $00400000,
  AW_MOVER_FLAG_DISABLE_TURN_ON_PLACE = $00800000,
  AW_MOVER_FLAG_DISABLE_TELEPORTS     = $01000000,
  AW_MOVER_FLAG_DETACH_ON_TELEPORT    = $02000000
);

type AW_MOVER_TYPES = (
  AW_MOVER_TYPE_PASSIVE,
  AW_MOVER_TYPE_ACTIVE,
  AW_MOVER_TYPE_ITEM
);

type AW_ZONE_FLAGS = (
  AW_ZONE_FLAG_WATER              = $001,
  AW_ZONE_FLAG_BLOCK_PARTICLES    = $002,
  AW_ZONE_FLAG_BLOCK_LIGHTS       = $004,
  AW_ZONE_FLAG_BLOCK_WORLD_LIGHT  = $008,
  AW_ZONE_FLAG_BLOCK_CHAT         = $010,
  AW_ZONE_FLAG_VISIBLE            = $020,
  AW_ZONE_FLAG_BLOCK_JOIN         = $040,
  AW_ZONE_FLAG_VOIP               = $080,
  AW_ZONE_FLAG_BLOCK_AUDIO        = $100
);

type AW_PARTICLE_FLAGS = (
  AW_PARTICLE_FLAG_INTERPOLATE    = $01,
  AW_PARTICLE_FLAG_GRAVITY        = $02,
  AW_PARTICLE_FLAG_COLLIDE_ZONES  = $04,
  AW_PARTICLE_FLAG_ZONE_EXCLUSIVE = $08,
  AW_PARTICLE_FLAG_CAMERA_EMIT    = $10,
  AW_PARTICLE_FLAG_MOVER_LINK     = $20,
  AW_PARTICLE_FLAG_DRAW_IN_FRONT  = $40,
  AW_PARTICLE_FLAG_APPLY_ROTATION = $80
);

type AW_CAMERA_FLAGS = (
  AW_CAMERA_FLAG_TRACK_USER       = $01
);

type AW_CLOTH_TYPES = (
  AW_CLOTH_TYPE_FABRIC    = 0,
  AW_CLOTH_TYPE_OBJECT,
  AW_CLOTH_TYPE_METAL_SHAPE
);

type AW_CLOTH_FLAGS = (
  AW_CLOTH_FLAG_GRAVITY             = $0001,
  AW_CLOTH_FLAG_STATIC              = $0002,
  AW_CLOTH_FLAG_COMDAMPING          = $0004,
  AW_CLOTH_FLAG_BENDING_ORTHO       = $0008,
  AW_CLOTH_FLAG_SELFCOLLISION       = $0010,
  AW_CLOTH_FLAG_COLLISION_TWO_WAY   = $0020,
  AW_CLOTH_FLAG_ATTACHMENT_TWO_WAY  = $0040,
  AW_CLOTH_FLAG_ATTACHMENT_TEARABLE = $0080,
  AW_CLOTH_FLAG_TEARABLE            = $0100,
  AW_CLOTH_FLAG_TEARABLE_DIAGONAL   = $0200, // fabric only
  AW_CLOTH_FLAG_PRESSURE            = $0400, // closed convex hulls only
  AW_CLOTH_FLAG_ADHERE              = $0800,
  AW_CLOTH_FLAG_UNTANGLING          = $1000,
  AW_CLOTH_FLAG_HARD_STRETCH_LIMIT  = $2000
);

type AW_CLOTH_ANCHORS = (
  AW_CLOTH_ANCHOR_NONE = 0,
  AW_CLOTH_ANCHOR_GLOBAL,
  AW_CLOTH_ANCHOR_OBJECT
);

type AW_CLOTH_ANCHOR_POS = (
  AW_CLOTH_ANCHOR_POS_CENTER = 0,
  AW_CLOTH_ANCHOR_POS_TOP,
  AW_CLOTH_ANCHOR_POS_BOTTOM,
  AW_CLOTH_ANCHOR_POS_LEFT,
  AW_CLOTH_ANCHOR_POS_RIGHT,
  AW_CLOTH_ANCHOR_POS_TOP_LEFT,
  AW_CLOTH_ANCHOR_POS_TOP_RIGHT,
  AW_CLOTH_ANCHOR_POS_BOTTOM_LEFT,
  AW_CLOTH_ANCHOR_POS_BOTTOM_RIGHT
);

type AW_CLOTH_FABRIC_SHAPES = (
  AW_CLOTH_FABRIC_SHAPE_QUAD = 0,
  AW_CLOTH_FABRIC_SHAPE_DISC
);

type AW_CLOTH_METAL_SHAPES = (
  AW_CLOTH_METAL_SHAPE_BOX = 0,
  AW_CLOTH_METAL_SHAPE_SPHERE,
  AW_CLOTH_METAL_SHAPE_CAPSULE
);

type AW_OBJECT_TYPES = (
  AW_OBJECT_TYPE_V3       = 0,
  AW_OBJECT_TYPE_UNKNOWN,
  AW_OBJECT_TYPE_ZONE,
  AW_OBJECT_TYPE_PARTICLES,
  AW_OBJECT_TYPE_MOVER,
  AW_OBJECT_TYPE_CAMERA,
  AW_MAX_OBJECT_TYPES
);

type AW_HUD_ORIGIN_TYPES = (
  AW_HUD_ORIGIN_TOP_LEFT  = 0,
  AW_HUD_ORIGIN_TOP,
  AW_HUD_ORIGIN_TOP_RIGHT,
  AW_HUD_ORIGIN_LEFT,
  AW_HUD_ORIGIN_CENTER,
  AW_HUD_ORIGIN_RIGHT,
  AW_HUD_ORIGIN_BOTTOM_LEFT,
  AW_HUD_ORIGIN_BOTTOM,
  AW_HUD_ORIGIN_BOTTOM_RIGHT
);

type AW_HUD_TYPES = (
  AW_HUD_TYPE_TEXT  = 0,
  AW_HUD_TYPE_IMAGE,
  AW_HUD_TYPE_MODEL
);

type AW_HUD_ELEMENT_FLAGS_ENUM = (
  AW_HUD_ELEMENT_FLAG_CLICKS        = $0001,
  AW_HUD_ELEMENT_FLAG_STRETCH       = $0002,
  AW_HUD_ELEMENT_FLAG_ADDITIVE      = $0004,
  AW_HUD_ELEMENT_FLAG_SIZE_PERCENT  = $0008,
  AW_HUD_ELEMENT_FLAG_TRANSITION    = $0010,
  AW_HUD_ELEMENT_FLAG_TEMPORARY     = $0020,
  AW_HUD_ELEMENT_FLAG_UNIVERSE_PATH = $0040,
  AW_HUD_ELEMENT_FLAG_CLAMP         = $0080,
  AW_HUD_ELEMENT_FLAG_HIGHLIGHT     = $0100
);

type AW_PRIVACY_TYPES = (
  AW_PRIVACY_BLOCK_TELEGRAMS  = $0001
);

// AW_WORLD_ENABLE_CAV flags
type AW_ENABLE_CAV_TYPES = (
  AW_ENABLE_CAV_CITIZEN       = $01,
  AW_ENABLE_CAV_BOT           = $02,
  AW_ENABLE_CAV_TOURIST       = $04,
  AW_ENABLE_CAV_WORLD_CITIZEN = $10,
  AW_ENABLE_CAV_WORLD_BOT     = $20,
  AW_ENABLE_CAV_WORLD_TOURIST = $40
);

// AW_XFER_TYPE
type AW_XFER_TYPES = (
  AW_XFER_TYPE_FILE     = 0,
  AW_XFER_TYPE_IMAGE,
  AW_XFER_TYPE_DOCUMENT,
  AW_XFER_TYPE_MEDIA,
  AW_XFER_TYPE_STORE,
  AW_XFER_TYPE_RETRIEVE
);

// AW_LASER_BEAM_SOURCE_TYPE
type AW_LASER_BEAM_SOURCE_TYPES = (
  AW_LASER_BEAM_SOURCE_TYPE_NONE    = 0,
  AW_LASER_BEAM_SOURCE_TYPE_AVATAR,
  AW_LASER_BEAM_SOURCE_TYPE_OBJECT,
  AW_LASER_BEAM_SOURCE_TYPE_COORDS
);

// AW_LASER_BEAM_TARGET_TYPE
type AW_LASER_BEAM_TARGET_TYPES = (
  AW_LASER_BEAM_TARGET_TYPE_NONE    = 0,
  AW_LASER_BEAM_TARGET_TYPE_AVATAR,
  AW_LASER_BEAM_TARGET_TYPE_OBJECT,
  AW_LASER_BEAM_TARGET_TYPE_COORDS
);

// AW_LASER_BEAM_STYLE
type AW_LASER_BEAM_STYLES = (
  AW_LASER_BEAM_STYLE_LINE          = 0,
  AW_LASER_BEAM_STYLE_PARTICLE
);

//-----------------------------------------------------------------------------
//                           e r r o r   c o d e s
//-----------------------------------------------------------------------------

type AW_ERROR_CODES = (
  RC_SUCCESS                            = 0,
  RC_CITIZENSHIP_EXPIRED                = 1,
  RC_LAND_LIMIT_EXCEEDED                = 2,
  RC_NO_SUCH_CITIZEN                    = 3,
  RC_MESSAGE_LENGTH_BAD                 = 4,
  RC_LICENSE_PASSWORD_CONTAINS_SPACE    = 5,
  RC_LICENSE_PASSWORD_TOO_LONG          = 6,
  RC_LICENSE_PASSWORD_TOO_SHORT         = 7,
  RC_LICENSE_RANGE_TOO_LARGE            = 8,
  RC_LICENSE_RANGE_TOO_SMALL            = 9,
  RC_LICENSE_USERS_TOO_LARGE            = 10,
  RC_LICENSE_USERS_TOO_SMALL            = 11,
  RC_LICENSE_CONTAINS_INVALID_CHAR      = 12,
  RC_INVALID_PASSWORD                   = 13,
  RC_UNABLE_TO_MAIL_BACK_NUMBER         = 14,
  RC_LICENSE_WORLD_TOO_SHORT            = 15,
  RC_LICENSE_WORLD_TOO_LONG             = 16,
  RC_SERVER_OUT_OF_MEMORY               = 17,
  RC_INVALID_WORLD                      = 20,
  RC_SERVER_OUTDATED                    = 21,
  RC_WORLD_ALREADY_STARTED              = 22,
  RC_NO_SUCH_WORLD                      = 27,
  RC_NOT_LOGGED_IN                      = 31,
  RC_UNAUTHORIZED                       = 32,
  RC_WORLD_ALREADY_EXISTS               = 33,
  RC_NO_SUCH_LICENSE                    = 34,
  RC_IDENTITY_ALREADY_IN_USE            = 39,
  RC_UNABLE_TO_REPORT_LOCATION          = 40,
  RC_INVALID_EMAIL                      = 41,
  RC_NO_SUCH_ACTING_CITIZEN             = 42,
  RC_ACTING_PASSWORD_INVALID            = 43,
  RC_UNIVERSE_FULL                      = 45,
  RC_BILLING_TIMEOUT                    = 46,
  RC_BILLING_RECV_FAILED                = 47,
  RC_BILLING_RESPONSE_INVALID           = 48,
  RC_BILLING_REJECTED                   = 55,
  RC_BILLING_BLOCKED                    = 56,
  RC_TOO_MANY_WORLDS                    = 57,
  RC_MUST_UPGRADE                       = 58,
  RC_BOT_LIMIT_EXCEEDED                 = 59,
  RC_WORLD_EXPIRED                      = 61,
  RC_CITIZEN_DOES_NOT_EXPIRE            = 62,
  RC_LICENSE_STARTS_WITH_NUMBER         = 64,
  RC_NO_SUCH_EJECTION                   = 66,
  RC_NO_SUCH_SESSION                    = 67,
  RC_EJECTION_EXPIRED                   = 69,
  RC_ACTING_CITIZEN_EXPIRED             = 70,
  RC_ALREADY_STARTED                    = 71,
  RC_WORLD_RUNNING                      = 72,
  RC_WORLD_NOT_SET                      = 73,
  RC_NO_SUCH_CELL                       = 74,
  RC_NO_REGISTRY                        = 75,
  RC_CANT_OPEN_REGISTRY                 = 76,
  RC_CITIZEN_DISABLED                   = 77,
  RC_WORLD_DISABLED                     = 78,
  RC_BETA_REQUIRED                      = 79,
  RC_ACTING_CITIZEN_DISABLED            = 80,
  RC_INVALID_USER_COUNT                 = 81,
  RC_TELEGRAM_BLOCKED                   = 85,
  RC_TELEGRAM_TOO_LONG                  = 86,
  RC_PRIVATE_WORLD                      = 91,
  RC_NO_TOURISTS                        = 92,
  RC_EMAIL_CONTAINS_INVALID_CHAR        = 100,
  RC_EMAIL_ENDS_WITH_BLANK              = 101, 
  RC_EMAIL_MISSING_DOT                  = 102, 
  RC_EMAIL_MISSING_AT                   = 103,
  RC_EMAIL_STARTS_WITH_BLANK            = 104,
  RC_EMAIL_TOO_LONG                     = 105,
  RC_EMAIL_TOO_SHORT                    = 106,
  RC_NAME_ALREADY_USED                  = 107,
  RC_NAME_CONTAINS_NONALPHANUMERIC_CHAR = 108,
  RC_NAME_CONTAINS_INVALID_BLANK        = 109,
  RC_NAME_DOESNT_EXIST                  = 110,
  RC_NAME_ENDS_WITH_BLANK               = 111,
  RC_NAME_TOO_LONG                      = 112,
  RC_NAME_TOO_SHORT                     = 113,
  RC_NAME_UNUSED                        = 114,
  RC_PASSWORD_TOO_LONG                  = 115,
  RC_PASSWORD_TOO_SHORT                 = 116,
  RC_PASSWORD_WRONG                     = 117,
  RC_UNABLE_TO_DELETE_NAME              = 119,
  RC_UNABLE_TO_GET_CITIZEN              = 120,
  RC_UNABLE_TO_INSERT_CITIZEN           = 121,
  RC_UNABLE_TO_INSERT_NAME              = 122,
  RC_UNABLE_TO_PUT_CITIZEN_COUNT        = 123,
  RC_UNABLE_TO_DELETE_CITIZEN           = 124,
  RC_NUMBER_ALREADY_USED                = 126,
  RC_NUMBER_OUT_OF_RANGE                = 127,
  RC_PRIVILEGE_PASSWORD_IS_TOO_SHORT    = 128,
  RC_PRIVILEGE_PASSWORD_IS_TOO_LONG     = 129,
  RC_OLD_DATABASE                       = 130,
  RC_START_TRANSACT_FAILED              = 131,
  RC_CALL_LIMIT_EXCEEDED                = 137,
  RC_BOTGRAM_SENT_TO_NONE               = 138,
  RC_NOT_CHANGE_OWNER                   = 203,
  RC_CANT_FIND_OLD_ELEMENT              = 204,
  RC_UNABLE_TO_CHANGE_ATTRIBUTE         = 210,
  RC_CANT_CHANGE_OWNER                  = 211,
  RC_IMPOSTER                           = 212,
  RC_INVALID_REQUEST                    = 213,
  RC_CANT_BUILD_HERE                    = 216,
  RC_NOT_ALLOWED                        = 232,
  RC_JOIN_REFUSED                       = 250,
  RC_ENCROACHES                         = 300,
  RC_NO_SUCH_OBJECT                     = 301,
  RC_NOT_DELETE_OWNER                   = 302,
  RC_TOO_MANY_BYTES                     = 303,
  RC_UNABLE_TO_STORE                    = 305,
  RC_UNREGISTERED_OBJECT                = 306,
  RC_ELEMENT_ALREADY_EXISTS             = 308,
  RC_RESTRICTED_COMMAND                 = 309,
  RC_NO_BUILD_RIGHTS                    = 310,
  RC_OUT_OF_BOUNDS                      = 311,
  RC_RESTRICTED_OBJECT                  = 313,
  RC_RESTRICTED_AREA                    = 314,
  RC_OUT_OF_MEMORY                      = 400,
  RC_NOT_YET                            = 401,
  RC_TIMEOUT                            = 402,
  RC_NULL_POINTER                       = 403,
  RC_UNABLE_TO_CONTACT_UNIVERSE         = 404,
  RC_UNABLE_TO_CONTACT_WORLD            = 405,
  RC_INVALID_WORLD_NAME                 = 406,
  RC_SEND_FAILED                        = 415,
  RC_RECEIVE_FAILED                     = 416,
  RC_STREAM_EMPTY                       = 421,
  RC_STREAM_MESSAGE_TOO_LONG            = 422,
  RC_WORLD_NAME_TOO_LONG                = 423,
  RC_MESSAGE_TOO_LONG                   = 426,
  RC_TOO_MANY_RESETS                    = 427,
  RC_UNABLE_TO_CREATE_SOCKET            = 428,
  RC_UNABLE_TO_CONNECT                  = 429,
  RC_UNABLE_TO_SET_NONBLOCKING          = 430,
  RC_CANT_OPEN_STREAM                   = 434,
  RC_CANT_WRITE_STREAM                  = 435,
  RC_CANT_CLOSE_STREAM                  = 436,
  RC_NO_CONNECTION                      = 439,
  RC_UNABLE_TO_INITIALIZE_NETWORK       = 442,
  RC_INCORRECT_MESSAGE_LENGTH           = 443,
  RC_NOT_INITIALIZED                    = 444,
  RC_NO_INSTANCE                        = 445,
  RC_OUT_BUFFER_FULL                    = 446,
  RC_INVALID_CALLBACK                   = 447,
  RC_INVALID_ATTRIBUTE                  = 448,
  RC_TYPE_MISMATCH                      = 449,
  RC_STRING_TOO_LONG                    = 450,
  RC_READ_ONLY                          = 451,
  RC_UNABLE_TO_REGISTER_RESOLVE         = 452,
  RC_INVALID_INSTANCE                   = 453,
  RC_VERSION_MISMATCH                   = 454,
  RC_IN_BUFFER_FULL                     = 461,
  RC_PROTOCOL_ERROR                     = 463,
  RC_QUERY_IN_PROGRESS                  = 464,
  RC_WORLD_FULL                         = 465,
  RC_EJECTED                            = 466,
  RC_NOT_WELCOME                        = 467,
  RC_UNABLE_TO_BIND                     = 468,
  RC_UNABLE_TO_LISTEN                   = 469,
  RC_UNABLE_TO_ACCEPT                   = 470,
  RC_CONNECTION_LOST                    = 471,
  RC_NO_STREAM                          = 473,
  RC_NOT_AVAILABLE                      = 474,
  RC_OLD_UNIVERSE                       = 487,
  RC_OLD_WORLD                          = 488,
  RC_WORLD_NOT_RUNNING                  = 489,
  RC_CANT_RESOLVE_UNIVERSE_HOST         = 500,
  RC_INVALID_ARGUMENT                   = 505,
  RC_WORLD_INSTANCE_ALREADY_EXISTS      = 521,
  RC_WORLD_INSTANCE_INVALID             = 522,
  RC_EMAIL_CHANGE_NOT_ALLOWED           = 525,
  RC_NAME_CHANGE_NOT_ALLOWED            = 526,
  RC_EMAIL_ALREADY_USED                 = 527,
  RC_EMAIL_NOT_ALLOWED                  = 528,
  RC_WORLD_REDIRECT                     = 529,
  RC_DATABASE_ERROR                     = 600
);

//-----------------------------------------------------------------------------
//                       v a r i a b l e s   t y p e s
//-----------------------------------------------------------------------------

// 3D vector
type aw_type_vector = packed record
  x: single;
  y: single;
  z: single;
end;

// 3D vector range, min and max
type aw_type_vector_range = packed record
  min: aw_type_vector;
  max: aw_type_vector;
end;

//-----------------------------------------------------------------------------
//             o b j e c t  t y p e  d a t a  s t r u c t u r e s
//-----------------------------------------------------------------------------

// AW_OBJECT_TYPE_ZONE
type aw_object_data_zone = packed record
  size: aw_type_vector;               // BBox, MUST be first item in struct!
  version: byte;                      // structure version (set by SDK)
  shape: byte;
  priority: shortint;
  gravity: single;
  friction: single;
  flags: word;                        // boolean flags
  color: longword;                    // COLORREF
  fog_min: word;
  fog_max: word;
  footstep_len: word;                 // length of 1st string in str_data
  ambient_len: word;                  // length of 2nd string in str_data
  camera_len: byte;                   // length of 3rd string in str_data
  target_cur_len: byte;               // length of 4th string in str_data
  voip_rights_len: byte;              // length of 5th string in str_data
  name_len: byte;                     // length of 6th string in str_data
  reserved: array [0..8] of byte;     // Bytes reserverd for future use
  // note: increase the strucure's total size
  // by the length of the strings
  // when allocating memory for this structure!
  // (str_data is the reference to the first byte)
  str_data: byte;
end;
paw_object_data_zone = ^aw_object_data_zone;

// AW_OBJECT_TYPE_PARTICLES
type aw_object_data_particles = packed record
  volume: aw_type_vector_range;           // BBox, MUST be first item in struct!
  version: byte;                          // structure version (set by SDK)
  speed: aw_type_vector_range;
  accel: aw_type_vector_range;
  angle: aw_type_vector_range;
  spin: aw_type_vector_range;
  size: aw_type_vector_range;
  release_min: longword;                  // time in ms
  release_max: longword;                  // time in ms
  release_size: word;                     // # of particles released
  lifespan: longword;                     // time in ms
  emitter_lifespan: longword;             // time in ms
  fade_in: longword;                      // time in ms
  fade_out: longword;                     // time in ms
  color_start: longword;                  // COLORREF
  color_end: longword;                    // COLORREF
  opacity: single;
  render_style: byte;
  flags: word;                            // boolean flags (interp, collide, gravity)
  style: byte;
  asset_list_len: word;                   // length of 1st string in str_data
  name_len: byte;                         // length of 2nd string in str_data
  reserved: array [0..11] of byte;        // Bytes reserverd for future use
  // note: increase the strucure's total size
  // by the length of the strings
  // when allocating memory for this structure!
  // (str_data is the reference to the first byte)
  str_data: byte;
end;
paw_object_data_particles = ^aw_object_data_particles;

// AW_OBJECT_TYPE_CAMERA
type aw_object_data_camera = packed record
  version: byte;                      // structure version (set by SDK)
  flags: word;
  zoom: single;
  name_len: byte;                     // length of 1st string in str_data
  reserved: array [0..11] of byte;    // Bytes reserverd for future use
  // note: increase the strucure's total size
  // by the length of the strings
  // when allocating memory for this structure!
  // (str_data is the reference to the first byte)
  str_data: byte;
end;
paw_object_data_camera = ^aw_object_data_camera;

// AW_OBJECT_TYPE_MOVER
type aw_object_data_mover = packed record
  version: byte;                          // structure version (set by SDK)
  otype: byte;
  flags: cardinal;
  locked_pos_x: smallint;
  locked_pos_y: smallint;
  locked_pos_z: smallint;
  locked_yaw: smallint;
  locked_pitch: smallint;
  glide_factor: shortint;                 // -100 to +100
  speed_factor: byte;                     // 0.0 to 25.5 max (* 10)
  friction_factor: byte;                  // 0.0 to 25.5 max (* 10)
  accel_tilt_x: shortint;                 // -127 to +127
  accel_tilt_z: shortint;                 // -127 to +127
  turn_factor: byte;                      // 0.0 to 25.5 max (* 10)
  avatar_tag: byte;                       // 0 to 255
  reserved1: array [0..8] of byte;        // Bytes reserverd for future use
  name_len: byte;                         // length of 1st string in str_data
  seq_len: byte;                          // length of 2nd string in str_data
  script_len: byte;                       // length of 3rd string in str_data
  sound_len: byte;                        // length of 4rd string in str_data
  waypoints_len: word;                    // length of 5th string in str_data
  bump_name_len: byte;                    // length of 6th string in str_data
  reserved2: array [0..1] of byte;        // Bytes reserverd for future use
  // note: increase the strucure's total size
  // by the length of the strings
  // when allocating memory for this structure!
  // (str_data is the reference to the first byte)
  str_data: byte;
end;
paw_object_data_mover = ^aw_object_data_mover;

type aw_waypoint = packed record
  x: smallint;
  y: smallint;
  z: smallint;
  yaw: smallint;
  pitch: smallint;
  roll: smallint;
  speed: word;
  pause: byte;
  flag: word;
end;

type
  AWCallbackProc = procedure (rc: integer); cdecl;
  AWEventProc = procedure; cdecl;
  AWDebugCallbackProc = procedure (debug_string: PAnsiChar); cdecl;
  sequence3x3 = array [0..2, 0..2] of integer;
  sequence5x5 = array [0..4, 0..4] of integer;

//-----------------------------------------------------------------------------
//                               m e t h o d s
//-----------------------------------------------------------------------------

function aw_init (build: integer): integer; cdecl; external 'aw.dll';
function aw_init_bind (build: integer; Addr: longword): integer; cdecl; external 'aw.dll';
procedure aw_term; cdecl; external 'aw.dll';
function aw_create (const domain: PAnsiChar; port: integer; var instance: pointer): integer; cdecl; external 'aw.dll';
function aw_createW (const domain: PWideChar; port: integer; var instance: pointer): integer; cdecl; external 'aw.dll';
function aw_create_resolved (address: longword; port: integer; var instance: pointer): integer; cdecl; external 'aw.dll';
function aw_destroy: integer; cdecl; external 'aw.dll';
function aw_instance: pointer; cdecl; external 'aw.dll';
function aw_instance_set (instance: pointer): integer; cdecl; external 'aw.dll';
function aw_login: integer; cdecl; external 'aw.dll';
function aw_wait (milliseconds: integer): integer; cdecl; external 'aw.dll';
function aw_int (a: AW_ATTRIBUTE): integer; cdecl; external 'aw.dll';
function aw_int_set (a: AW_ATTRIBUTE; value: integer): integer; cdecl; external 'aw.dll';
function aw_string (a: AW_ATTRIBUTE): PAnsiChar; cdecl; external 'aw.dll';
function aw_stringW (a: AW_ATTRIBUTE): PWideChar; cdecl; external 'aw.dll';
function aw_string_set (a: AW_ATTRIBUTE; const value: PAnsiChar): integer; cdecl; external 'aw.dll';
function aw_string_setW (a: AW_ATTRIBUTE; const value: PWideChar): integer; cdecl; external 'aw.dll';
function aw_bool (a: AW_ATTRIBUTE): integer; cdecl; external 'aw.dll';
function aw_bool_set (a: AW_ATTRIBUTE; value: integer): integer; cdecl; external 'aw.dll';
function aw_float (a: AW_ATTRIBUTE): single; cdecl; external 'aw.dll';
function aw_float_set (a: AW_ATTRIBUTE; value: single): integer; cdecl; external 'aw.dll';
function aw_data (a: AW_ATTRIBUTE; var length: cardinal): PChar; cdecl; external 'aw.dll';
function aw_data_set (a: AW_ATTRIBUTE; const value: PChar; length: cardinal): integer; cdecl; external 'aw.dll';
function aw_callback (c: AW_CALLBACK_ATTRIBUTE): AWCallbackProc; cdecl; external 'aw.dll';
function aw_callback_set (c: AW_CALLBACK_ATTRIBUTE; callback: AWCallbackProc): integer; cdecl; external 'aw.dll';
function aw_instance_callback_set (c: AW_CALLBACK_ATTRIBUTE; callback: AWCallbackProc): integer; cdecl; external 'aw.dll';
function aw_event (a: AW_EVENT_ATTRIBUTE): AWEventProc; cdecl; external 'aw.dll';
function aw_event_set (a: AW_EVENT_ATTRIBUTE; handler: AWEventProc): integer; cdecl; external 'aw.dll';
function aw_instance_event_set (a: AW_EVENT_ATTRIBUTE; handler: AWEventProc): integer; cdecl; external 'aw.dll';
function aw_enter (const world: PAnsiChar): integer; cdecl; external 'aw.dll';
function aw_enterW (const world: PWideChar): integer; cdecl; external 'aw.dll';
function aw_exit: integer; cdecl; external 'aw.dll';
function aw_say (const msg: PAnsiChar): integer; cdecl; external 'aw.dll';
function aw_sayW (const msg: PWideChar): integer; cdecl; external 'aw.dll';
function aw_whisper (session_id: integer; const msg: PAnsiChar): integer; cdecl; external 'aw.dll';
function aw_whisperW (session_id: integer; const msg: PWideChar): integer; cdecl; external 'aw.dll';
function aw_state_change: integer; cdecl; external 'aw.dll';
function aw_citizen_attributes_by_name (const name: PAnsiChar): integer; cdecl; external 'aw.dll';
function aw_citizen_attributes_by_nameW (const name: PWideChar): integer; cdecl; external 'aw.dll';
function aw_citizen_attributes_by_number (citizen: integer): integer; cdecl; external 'aw.dll';
function aw_citizen_add: integer; cdecl; external 'aw.dll';
function aw_citizen_change: integer; cdecl; external 'aw.dll';
function aw_citizen_delete (citizen: integer): integer; cdecl; external 'aw.dll';
function aw_citizen_next: integer; cdecl; external 'aw.dll';
function aw_citizen_previous: integer; cdecl; external 'aw.dll';
function aw_cav_request (citizen: integer; session: integer): integer; cdecl; external 'aw.dll';
function aw_cav_change: integer; cdecl; external 'aw.dll';
function aw_cav_delete: integer; cdecl; external 'aw.dll';
function aw_world_cav_request (citizen: integer; session: integer): integer; cdecl; external 'aw.dll';
function aw_world_cav_change: integer; cdecl; external 'aw.dll';
function aw_world_cav_delete: integer; cdecl; external 'aw.dll';
function aw_license_add: integer; cdecl; external 'aw.dll';
function aw_license_attributes (const name: PAnsiChar): integer; cdecl; external 'aw.dll';
function aw_license_attributesW (const name: PWideChar): integer; cdecl; external 'aw.dll';
function aw_license_change: integer; cdecl; external 'aw.dll';
function aw_license_delete (const name: PAnsiChar): integer; cdecl; external 'aw.dll';
function aw_license_deleteW (const name: PWideChar): integer; cdecl; external 'aw.dll';
function aw_license_next: integer; cdecl; external 'aw.dll';
function aw_license_previous: integer; cdecl; external 'aw.dll';
function aw_world_list: integer; cdecl; external 'aw.dll';
function aw_object_add: integer; cdecl; external 'aw.dll';
function aw_object_change: integer; cdecl; external 'aw.dll';
function aw_object_delete: integer; cdecl; external 'aw.dll';
function aw_object_load: integer; cdecl; external 'aw.dll';
function aw_object_query: integer; cdecl; external 'aw.dll';
function aw_query (x_sector: integer; z_sector: integer; sequence: sequence3x3): integer; cdecl; external 'aw.dll';
function aw_query_5x5 (x_sector: integer; z_sector: integer; sequence: sequence5x5): integer; cdecl; external 'aw.dll';
function aw_random: integer; cdecl; external 'aw.dll';
function aw_world_attributes_change: integer; cdecl; external 'aw.dll';
function aw_universe_attributes_change: integer; cdecl; external 'aw.dll';
function aw_session: integer; cdecl; external 'aw.dll';
function aw_world_eject: integer; cdecl; external 'aw.dll';
function aw_sector_from_cell (cell: integer): integer; cdecl; external 'aw.dll';
function aw_universe_ejection_add: integer; cdecl; external 'aw.dll';
function aw_universe_ejection_delete (address: integer): integer; cdecl; external 'aw.dll';
function aw_universe_ejection_lookup: integer; cdecl; external 'aw.dll';
function aw_universe_ejection_next: integer; cdecl; external 'aw.dll';
function aw_universe_ejection_previous: integer; cdecl; external 'aw.dll';
function aw_object_click: integer; cdecl; external 'aw.dll';
function aw_object_select: integer; cdecl; external 'aw.dll';
function aw_avatar_click (session_id: integer): integer; cdecl; external 'aw.dll';
function aw_address (session_id: integer): integer; cdecl; external 'aw.dll';
function aw_url_send (session_id: integer; const url: PAnsiChar; const target: PAnsiChar): integer; cdecl; external 'aw.dll';
function aw_url_sendW (session_id: integer; const url: PWideChar; const target: PWideChar): integer; cdecl; external 'aw.dll';
function aw_url_click (const url: PAnsiChar): integer; cdecl; external 'aw.dll';
function aw_url_clickW (const url: PWideChar): integer; cdecl; external 'aw.dll';
function aw_teleport (session_id: integer): integer; cdecl; external 'aw.dll';
function aw_world_ejection_add: integer; cdecl; external 'aw.dll';
function aw_world_ejection_delete: integer; cdecl; external 'aw.dll';
function aw_world_ejection_lookup: integer; cdecl; external 'aw.dll';
function aw_world_ejection_next: integer; cdecl; external 'aw.dll';
function aw_world_ejection_previous: integer; cdecl; external 'aw.dll';
function aw_world_attribute_set (attribute: integer; value: PAnsiChar): integer; cdecl; external 'aw.dll';
function aw_world_attribute_setW (attribute: integer; value: PWideChar): integer; cdecl; external 'aw.dll';
function aw_world_attribute_get (attribute: integer; var read_only: integer; value: PAnsiChar): integer; cdecl; external 'aw.dll';
function aw_world_attribute_getW (attribute: integer; var read_only: integer; value: PWideChar): integer; cdecl; external 'aw.dll';
function aw_delete_all_objects: integer; cdecl; external 'aw.dll';
function aw_cell_next: integer; cdecl; external 'aw.dll';
function aw_world_reload_registry: integer; cdecl; external 'aw.dll';
function aw_world_attributes_reset: integer; cdecl; external 'aw.dll';
function aw_terrain_set (x: integer; z: integer; count: integer; texture: integer; heights: pointer): integer; cdecl; external 'aw.dll';
function aw_terrain_query (page_x: integer; page_z: integer; sequence: longword): integer; cdecl; external 'aw.dll';
function aw_terrain_next: integer; cdecl; external 'aw.dll';
function aw_terrain_delete_all: integer; cdecl; external 'aw.dll';
function aw_terrain_load_node: integer; cdecl; external 'aw.dll';
function aw_console_message (session_id: integer): integer; cdecl; external 'aw.dll';
function aw_user_data_set (data: pointer): integer; cdecl; external 'aw.dll';
function aw_user_data: pointer; cdecl; external 'aw.dll';
function aw_avatar_set (session_id: integer): integer; cdecl; external 'aw.dll';
function aw_avatar_reload (citizen: integer; session_id: integer): integer; cdecl; external 'aw.dll';
function aw_avatar_location (citizen: integer; session_id: integer; name: PAnsiChar): integer; cdecl; external 'aw.dll';
function aw_avatar_locationW (citizen: integer; session_id: integer; name: PWideChar): integer; cdecl; external 'aw.dll';
function aw_world_instance_set (citizen: integer; world_instance: integer): integer; cdecl; external 'aw.dll';
function aw_world_instance_get (citizen: integer): integer; cdecl; external 'aw.dll';
function aw_botgram_send: integer; cdecl; external 'aw.dll';
function aw_toolbar_click: integer; cdecl; external 'aw.dll';
function aw_user_list: integer; cdecl; external 'aw.dll';
function aw_noise (session_id: integer): integer; cdecl; external 'aw.dll';
function aw_world_attributes_send (session_id: integer): integer; cdecl; external 'aw.dll';
function aw_camera_set (session_id: integer): integer; cdecl; external 'aw.dll';
function aw_botmenu_send: integer; cdecl; external 'aw.dll';
function aw_object_bump: integer; cdecl; external 'aw.dll';

function aw_mover_set_state (id: integer; state: integer; model_num: integer): integer; cdecl; external 'aw.dll';
function aw_mover_set_position (id: integer; x: integer; y: integer; z: integer; yaw: integer; pitch: integer; roll: integer): integer; cdecl; external 'aw.dll';
function aw_mover_rider_add (id: integer; session: integer; dist: integer; angle: integer; y_delta: integer; yaw_delta: integer; pitch_delta: integer): integer; cdecl; external 'aw.dll';
function aw_mover_rider_change (id: integer; session: integer; dist: integer; angle: integer; y_delta: integer; yaw_delta: integer; pitch_delta: integer): integer; cdecl; external 'aw.dll';
function aw_mover_rider_delete (id: integer; session: integer): integer; cdecl; external 'aw.dll';
function aw_mover_links (id: integer): integer; cdecl; external 'aw.dll';

// object-type specific macro methods

function aw_object_zone_set (
            size: aw_type_vector; shape: byte; priority: shortint;
            gravity: single; friction: single; flags: word; color: longword;
            fog_min: word; fog_max: word;
            footstep: PChar; ambient: PChar; camera: PChar; target_cur: PChar;
            voip_rights: PChar; name: PChar): integer; cdecl; external 'aw.dll';
function aw_object_zone (var len: integer): paw_object_data_zone; cdecl; external 'aw.dll';
function aw_object_particles_set (
            volume: aw_type_vector_range; speed: aw_type_vector_range;
            accel: aw_type_vector_range; angle: aw_type_vector_range;
            spin: aw_type_vector_range; size: aw_type_vector_range;
            release_min: longword; release_max: longword; release_size: word;
            lifespan: longword; emitter_lifespan: longword;
            fade_in: longword; fade_out: longword;
            color_start: longword; color_end: longword;
            opacity: single; render_style: byte; flags: word; style: byte;
            asset_list: PChar; name: PChar): integer; cdecl; external 'aw.dll';
function aw_object_particles (var len: integer): paw_object_data_particles; cdecl; external 'aw.dll';
function aw_object_camera_set (flags: word; zoom: single; name: PChar): integer; cdecl; external 'aw.dll';
function aw_object_camera (var len: integer): paw_object_data_camera; cdecl; external 'aw.dll';
function aw_object_mover_set (otype: byte; flags: word;
            locked_pos_x, locked_pos_y, locked_pos_z, locked_yaw, locked_pitch: smallint;
            glide_factor: shortint; speed_factor, friction_factor: byte;
            accel_tilt_x, accel_tilt_z: shortint; turn_factor, avatar_tag: byte;
            name, seq, script, sound: PChar;
            waypoints_len: word; waypoints: pointer; bump_name: PChar): integer; cdecl; external 'aw.dll';
function aw_object_mover (var len: integer): paw_object_data_mover; cdecl; external 'aw.dll';

// gui control methods

function aw_hud_create: integer; cdecl; external 'aw.dll';
function aw_hud_click: integer; cdecl; external 'aw.dll';
function aw_hud_destroy (session: integer; id: integer): integer; cdecl; external 'aw.dll';
function aw_hud_clear (session: integer): integer; cdecl; external 'aw.dll';

// laser beam methods

function aw_laser_beam (): integer; cdecl; external 'aw.dll';

// utility methods

function aw_tick: cardinal; cdecl; external 'aw.dll';
function aw_check_right (citizen: integer; str: PAnsiChar): integer; cdecl; external 'aw.dll';
function aw_check_rightW (citizen: integer; str: PWideChar): integer; cdecl; external 'aw.dll';
function aw_check_right_all (str: PAnsiChar): integer; cdecl; external 'aw.dll';
function aw_check_right_allW (str: PWideChar): integer; cdecl; external 'aw.dll';
function aw_has_world_right (citizen: integer; right: AW_ATTRIBUTE): integer; cdecl; external 'aw.dll';
function aw_has_world_right_all (right: AW_ATTRIBUTE): integer; cdecl; external 'aw.dll';
function aw_traffic_count (var traffic_in: integer; var traffic_out: integer): integer; cdecl; external 'aw.dll';
function aw_zip (data_out: PChar; var len_out: cardinal; data_in: PChar; len_in: cardinal): integer; cdecl; external 'aw.dll';
function aw_unzip (data_out: PChar; var len_out: cardinal; data_in: PChar; len_in: cardinal): integer; cdecl; external 'aw.dll';

function aw_string_to_unicode (str: PAnsiChar): PWideChar; cdecl; external 'aw.dll';
function aw_string_from_unicode (str: PWideChar): PAnsiChar; cdecl; external 'aw.dll';
procedure aw_string_set_MBCS_codepage (codepage: cardinal); cdecl; external 'aw.dll';

// world server admin methods

function aw_server_admin (const domain: PAnsiChar; port: integer; password: PAnsiChar; var instance: pointer): integer; cdecl; external 'aw.dll';
function aw_server_adminW (const domain: PWideChar; port: integer; password: PWideChar; var instance: pointer): integer; cdecl; external 'aw.dll';
function aw_server_world_add: integer; cdecl; external 'aw.dll';
function aw_server_world_delete (id: integer): integer; cdecl; external 'aw.dll';
function aw_server_world_change (id: integer): integer; cdecl; external 'aw.dll';
function aw_server_world_list: integer; cdecl; external 'aw.dll';
function aw_server_world_start (id: integer): integer; cdecl; external 'aw.dll';
function aw_server_world_stop (id: integer): integer; cdecl; external 'aw.dll';
function aw_server_world_set (id: integer): integer; cdecl; external 'aw.dll';
function aw_server_world_instance_set (id: integer): integer; cdecl; external 'aw.dll';
function aw_server_world_instance_add (id: integer; instance_id: integer): integer; cdecl; external 'aw.dll';
function aw_server_world_instance_delete (id: integer; instance_id: integer): integer; cdecl; external 'aw.dll';

// methods below are not currently available in the SDK
{
function aw_contact_add (citizen: integer; options: cardinal): integer; cdecl; external 'aw.dll';
function aw_contact_add_by_name (name: PAnsiChar; options: cardinal): integer; cdecl; external 'aw.dll';
function aw_contact_add_by_nameW (name: PWideChar; options: cardinal): integer; cdecl; external 'aw.dll';
function aw_contact_change (citizen: integer; options: cardinal): integer; cdecl; external 'aw.dll';
function aw_contact_confirm (citizen: integer; options: cardinal): integer; cdecl; external 'aw.dll';
function aw_contact_delete (citizen: integer): integer; cdecl; external 'aw.dll';
function aw_contact_list (start: integer): integer; cdecl; external 'aw.dll';
function aw_afk_set (flag: integer): integer; cdecl; external 'aw.dll';
function aw_telegram_send (name: PAnsiChar; msg: PAnsiChar): integer; cdecl; external 'aw.dll';
function aw_telegram_sendW (name: PWideChar; msg: PWideChar): integer; cdecl; external 'aw.dll';
function aw_join (citizen: integer): integer; cdecl; external 'aw.dll';
function aw_join_reply (citizen: integer; reply_rc: integer): integer; cdecl; external 'aw.dll';
function aw_password_send: integer; cdecl; external 'aw.dll';
function aw_immigrate: integer; cdecl; external 'aw.dll';
function aw_register (renewal: integer): integer; cdecl; external 'aw.dll';
function aw_send_file: integer; cdecl; external 'aw.dll';
function aw_send_file_reply (reply_rc: integer): integer; cdecl; external 'aw.dll';
procedure aw_login_timeout_set (timeout: integer); cdecl; external 'aw.dll';
function aw_tunnel_set (const domain: PAnsiChar; port: word): integer; cdecl; external 'aw.dll';
function aw_tunnel_setW (const domain: PWideChar; port: word): integer; cdecl; external 'aw.dll';
function aw_tunnel_set_resolved (address: longword; port: word): integer; cdecl; external 'aw.dll';
function aw_proxy_set (const domain: PAnsiChar; port: word): integer; cdecl; external 'aw.dll';
function aw_proxy_setW (const domain: PWideChar; port: word): integer; cdecl; external 'aw.dll';
function aw_proxy_set_resolved (address: longword; port: word): integer; cdecl; external 'aw.dll';
function aw_proxy_set_login (const name: PAnsiChar; const password: PAnsiChar): integer; cdecl; external 'aw.dll';
function aw_proxy_set_loginW (const name: PWideChar; const password: PWideChar): integer; cdecl; external 'aw.dll';
function aw_connection: integer; cdecl; external 'aw.dll';
function aw_connection_set (ctype: integer): integer; cdecl; external 'aw.dll';
function aw_connection_state (instance: pointer): integer; cdecl; external 'aw.dll';
function aw_voip_data (data: pointer; len: cardinal): integer; cdecl; external 'aw.dll';
function aw_voip_group_set (group: integer; rights: PAnsiChar): integer; cdecl; external 'aw.dll';
function aw_voip_group_setW (group: integer; rights: PWideChar): integer; cdecl; external 'aw.dll';
function aw_voipcast_set (const domain: PAnsiChar; port: word): integer; cdecl; external 'aw.dll';
function aw_voipcast_setW (const domain: PWideChar; port: word): integer; cdecl; external 'aw.dll';
function aw_voipcast_set_resolved (address: longword; port: word): integer; cdecl; external 'aw.dll';
function aw_voipcast_ready: integer; cdecl; external 'aw.dll';
function aw_debug_callback_set (callback: AWDebugCallbackProc): integer; cdecl; external 'aw.dll';

function aw_xfer_offer: integer; cdecl; external 'aw.dll';
function aw_xfer_reply: integer; cdecl; external 'aw.dll';
function aw_xfer_send: integer; cdecl; external 'aw.dll';
function aw_xfer_request: integer; cdecl; external 'aw.dll';
function aw_xfer_request_show (const showName: PAnsiChar; ShowSequence: integer; const WorldName: PAnsiChar;
         const ZoneName: PAnsiChar; const TagName: PAnsiChar): integer; cdecl; external 'aw.dll';
function aw_xfer_request_showW (const showName: PWideChar; ShowSequence: integer; const WorldName: PWideChar;
         const ZoneName: PWideChar; const TagName: PWideChar): integer; cdecl; external 'aw.dll';
function aw_xfer_cancel: integer; cdecl; external 'aw.dll';
function aw_xfer_query: integer; cdecl; external 'aw.dll';
}
implementation

end.
